/*
 * Header file for the C++ ICE encryption class.
 *
 * Written by Matthew Kwan - July 1996
 */

#ifndef _IceKey_H
#define _IceKey_H

class IceSubkey;

class IceKey {
    public:
	IceKey (int n);
	~IceKey ();

	void		set (const unsigned char *key);

	unsigned char	*encrypt (const unsigned char *plaintext,
						unsigned char *ciphertext);

	unsigned char	*decrypt (const unsigned char *ciphertext,
						unsigned char *plaintext);

    private:
	void		scheduleBuild (unsigned short *k, int n,
							const int *keyrot);

	int		_size;
	int		_rounds;
	IceSubkey	*_keysched;
};

#endif
